# Keras - Eine Einführung in das Maschinelle Lernen mit Tensorflow

Diese Sammlung bietet eine Einführung in das Thema Maschinelles Lernen und die Verwendung der Deep-Learning API Keras.

## Installation

Der einfachste Weg mit dieser Dokumentation zu arbeiten, ist eine aktuelle Installation von [Anaconda](https://www.anaconda.com/products/individual).

Zusätzlich wird die Installation von Tensorflow benötigt, in welcher seit Tensorflow 1.4 auch Keras enthalten ist. Die Installation funtioniert sowohl über pip als auch über conda mit den folgenden Befehlen. 

```bash
conda install tensorflow
```

```bash
pip install tensorflow
```

Getestet mit:
 Conda 4.10.1
 Python 3.8.5
 tensorflow-gpu 2.4.1

## Benutzung

Eine umfangreiche Einführung in das Thema Machine Learning und die Benutzung des HPC Clusters findet man in der Dokumentation. Eine kompakte Version bieten die Folien. Im Notebooks-Ordner sind alle Jupyter-Notebooks zu finden auf die in der Dokumentation und den Folien eingegangen wird. Beschäftigt wird sich im wesentlichen mit der Erstellung von zwei Neuronalen Netzen: Einem Netzwerk für die Klassifizierung von handschriftlich geschriebenen Ziffern und einem Netzwerk für für die Klassifizierung von SDSS Spektren. Während die notebooks gut zum Lernen und herumexperimentieren sind, bieten sich die Python Dateien im scripts Ordner zur direkten Ausführung an.

## Framework
Conda 4.10.1

Python 3.8.5

tensorflow 2.5.0

## Credits
Joshua Roshlaub 2022

## Contact
Caroline Heneka caroline.heneka@uni-hamburg.de
Joshua Roshlaub joshuaroschlaub1999@gmail.com
